#include <OpenAudio_ArduinoLibrary.h>
#include "BAGuitar.h"
using namespace BAGuitar;
#include "Audio_Tool.h"
#include "note_frequency.h"
#define FLANGE_DELAY_LENGTH (4*AUDIO_BLOCK_SAMPLES)
#include "MIDI.h"
#include "usb_midi.h"
#define Debug 1
#define ledPin 13

//AudioSynthWaveformHarmModulated *instrument[] = {&harm_fm1, &harm_fm2, &harm_fm3, &harm_fm4, &harm_fm5, &harm_fm6};
//AudioSynthWaveformDc *dcs[] = {&dc1, &dc2, &dc3, &dc4, &dc5, &dc6};
AudioSynthWaveformHarmModulated *instrument[] = {&harm_fm1};
AudioSynthWaveformDc *dcs[] = {&dc1};
#include "harminstr.h"
HarmInstrument HarmInst;

extern AudioSynthWaveformHarmModulated *instrument[];
void createHarmgen(int firstv, int lastv, char * filename) {
  int nh = 16;
  float levels[16][128];
  float freqlist[16];
  float offlist[16];
  float phaselist[16];
  HarmInst.init(nh, 16, 1);

  for (int i = 0; i < nh; i++)
  {
    for (int j = 0; j < 128; j++)
      levels[i][j] = 0.0;
    HarmInst.partials[i]->setUp(levels[i]);
    freqlist[i] = i + 1;
    offlist[i] = 0;
    phaselist[i] = 0;
  }
  HarmInst.setVoice(firstv, lastv, freqlist, offlist, phaselist);
}

int busy[] = { -1, -1, -1, -1, -1, -1};
int MP[] = {1, 1, 1, 1, 1, 1, 1};
byte eeprom[16 * 1024];


float fmap(float x, float in_min, float in_max, float out_min, float out_max)
{
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
MIDI_CREATE_DEFAULT_INSTANCE();
int last_wf1 = 0;
int last_wf2 = 0;
byte click = 1;
bool b1 = false, b2 = false, b3 = false, b4 = false;
#define SDCARD_CS_PIN    BUILTIN_SDCARD
#define SDCARD_MOSI_PIN  11  // not actually used
#define SDCARD_SCK_PIN   13  // not actually used
// Allocate the delay lines for left and right channels
float setf = 0.0;
//The setup function is called once when the system starts up
bool alarm = false;
bool debug = false;
#include "MidiCC.h"
void setup(void) {
  //Start the USB serial link (to enable debugging)
  Serial.begin(115200);
  AudioNoInterrupts();
  AudioMemory_F32(12);
  AudioMemory(128);
  delay(3000);
  Serial.println(String("Starting...\n"));
  delay(1000);
  Serial.println("Enabling codec...\n");
  codec.enable();
  delay(1000);
  MIDI.begin(MIDI_CHANNEL_OMNI);
  MIDI.setHandleNoteOff(OnNoteOff);
  MIDI.setHandleNoteOn(OnNoteOn) ;
  MIDI.setHandleControlChange(OnControlChange);
  MIDI.setHandleSystemExclusive(OnSysEx);
  MIDI.setHandlePitchBend(OnPitchChange);
  //  usbMIDI.begin(MIDI_CHANNEL_OMNI);
  usbMIDI.setHandleNoteOff(OnNoteOff);
  usbMIDI.setHandleNoteOn(OnNoteOn) ;
  usbMIDI.setHandleControlChange(OnControlChange);
  usbMIDI.setHandleSysEx(OnSysExUSB);
  //Allocate dynamically shuffled memory for the audio subsystem
  memset(eeprom, -1, 16 * 1024);
  if (!(SD.begin(SDCARD_CS_PIN))) {
    // stop here if no SD card, but print a message
    while (!(SD.begin(SDCARD_CS_PIN))) {
      Serial.println("Unable to access the SD card");
      delay(500);
    }
  }
  filter1.frequency(3500);
  filter3.frequency(2500);
  mixer3.gain(1, 0);
  BA_delayExt1.delay(0, 0);
  BA_delayExt1.delay(1, 0);
  BA_delayExt1.delay(2, 0);
  BA_delayExt1.delay(3, 0);
  File frec;
  createHarmgen(0, 1, (char *) "I7.ins");
#if 1
  Serial.println("loading instrument ");
  if (SD.exists("Harm.ins")) {
    frec = SD.open("Harm.ins", FILE_READ);
    if (frec) {
      HarmInst.Restore(frec);
      Serial.println("Instr loaded");
      frec.close();
      HarmInst.attach(instrument[0]);
    }
  }
#endif

  frec = SD.open("Harm.pre", FILE_READ);
  if (frec) {
    frec.read(eeprom, 16 * 1024);
    frec.read(&click, 1);
    frec.close();
    //    Serial.printf(eeprom);
    Serial.println("reading presets");
    for (int msb = 0; msb < 16; msb++)
    {
      //      Serial.print(msb);
      //      Serial.print(" ");
      for (int lsb = 0; lsb < 32; lsb++)
      {
        byte val = eeprom[msb * 128 + lsb];
        //        Serial.print(lsb);
        //        Serial.print(" ");
        if (val != -1)
          OnNrpn( msb, lsb, val);
      }
      //      Serial.println(" ");
    }
  }
  omni = false;
  pinMode(ledPin, OUTPUT);
  Serial.println("Setup complete.");
  digitalWrite(ledPin, HIGH);
  count = 0;
  AudioInterrupts();
}
int msb = 0;
int lsb = 0;
float nrpv = 0;
int count = 0;
bool blinkon = false;
void loop(void) {
  if (noff )
  {
    if (dc1.read() == 0)
      instrument[0]->noteOff(1, 0);

  }
  int mid = MIDI.read();
  int usb = usbMIDI.read();
  int t = mid ? MIDI.getType() : usb ? usbMIDI.getType() : -1;
  count++;
  if (count > 10000 && !alarm || count > 100000)
  {
    count = 0;
    digitalWrite(ledPin, LOW);
    blinkon = false;
  }
  if (t == -1 || t == 254 || (t != 176 && t != 3))
  {
    return;
  }
  digitalWrite(ledPin, HIGH);
  blinkon = true;

  count = 0;
  int data1 = mid ? MIDI.getData1() : usbMIDI.getData1();
  float data2 = mid ? MIDI.getData2() : usbMIDI.getData2();
  switch ( data1)
  {
    case 38:
      OnNrpn2( msb, lsb, nrpv , data2 / 100.0);
      if (debug)
      {
        Serial.print("NRPN 2 ");
        Serial.print(nrpv);
        Serial.print(" + ");
        Serial.print((float)data2 / 100.0);
      }
      break;
    case 99:
      msb = data2;
      break;
    case 98:
      lsb = data2;
      break;
    case 6:
      if (debug)
      {
        Serial.print(" nrpn ");
        Serial.print(msb);
        Serial.print(",");
        Serial.print(lsb);
        Serial.print("=");
        Serial.println(data2);
      }
      OnNrpn( msb, lsb, data2);
      nrpv = data2;
      break;
  }
}




