
void reset(int fs, int ls, int p)
{
  if (ls == -1 || ls > 127)
    ls = 127;
  if (debug)
  {
    Serial.print("Resetting ... ");
    Serial.print(p);
    Serial.print(" ");
    Serial.print(fs);
    Serial.print(" -> ");
    Serial.println(ls);
  }

  for (int t = fs; t < ls; t++)
  {
    HarmInst.partials[p]->levels[t] = 0;
    HarmInst.partials[p]->slopes[t] = 0;
    HarmInst.partials[p]->amps[t] = 1;
    HarmInst.partials[p]->times[t] = 64;
  }
}
void resetsel(void)
{
  if (debug)
  {
    Serial.print("Resetting selection ... ");
    Serial.print(part);
    Serial.print(" ");
    Serial.print(mark);
    Serial.print(" -> ");
    Serial.println(endmark);
  }

  for (int t = mark; t <= endmark; t++)
  {
    HarmInst.partials[part]->levels[t] = 0;
    HarmInst.partials[part]->slopes[t] = 0;
    HarmInst.partials[part]->amps[t] = 1;
    HarmInst.partials[part]->times[t] = 64;
  }
}
void reverse(int p)
{
  Partial *cpart = HarmInst.partials[p];
  int ls = cpart->numseg;
  if (mark > -1)
  {
    for (int i = 0; i < (endmark - mark) / 2 + 1; i++)
    {
      int swap = endmark - i;
      float tmp = cpart->levels[mark + i];
      cpart->levels[mark + i] = cpart->levels[swap];
      cpart->levels[swap] = tmp;
      tmp = cpart->amps[mark + i];
      cpart->amps[mark + i] = cpart->amps[swap];
      cpart->amps[swap] = tmp;
      tmp = cpart->times[mark + i];
      cpart->times[mark + i] = cpart->times[swap];
      cpart->times[swap] = tmp;
      if (debug)
      {
        Serial.print(mark + i);
        Serial.print(" ");
        Serial.print(cpart->levels[mark + i]);
        Serial.print(" ");
        Serial.print(swap);
        Serial.print(" ");
        Serial.println(cpart->levels[swap]);
      }
    }
    return;
  }
  for (int t = 0; t < ls / 2; t++)
  {
    Partial *cpart = HarmInst.partials[p];
    int swap = ls - 1 - t;
    float tmp = cpart->levels[t];
    cpart->levels[t] = cpart->levels[swap];
    cpart->levels[swap] = tmp;
    tmp = cpart->amps[t];
    cpart->amps[t] = cpart->amps[swap];
    cpart->amps[swap] = tmp;
    tmp = cpart->times[t];
    cpart->times[t] = cpart->times[swap];
    cpart->times[swap] = tmp;
    if (debug)
    {
      Serial.print(t);
      Serial.print(" ");
      Serial.print(HarmInst.partials[p]->levels[t]);
      Serial.print(" ");
      Serial.print(swap);
      Serial.print(" ");
      Serial.println(HarmInst.partials[p]->levels[swap]);
    }
  }
}
void OnNrpn2(int msb, int lsb, float val, float val2)
{
  if (val > 127)
    return;
    if(debug)
      Serial.println(val+val2);
  switch (msb)
  {
    case 10:
      {
        float v = (val + val2) / 50.0 - 1;
#if 0
        Serial.print(val + val2);
        Serial.print(" => ");
        Serial.println(v);
#endif
        if (!spread)
        {
          HarmInst.setlevels(part, lsb,  v);
          HarmInst.partials[part]->setUp(lsb);
        }
        for (int t = 0; t < HarmInst.partials[part]->numseg && spread; t++)
        {
          HarmInst.setlevels(part, t, v);
          HarmInst.partials[part]->slopes[t] = 0.0;
        }
      }
      break;
    case 16:
      HarmInst.setFreq(lsb, val + val2);
      //       Serial.print("setf ");
      //       Serial.println(lsb);
      break;

  }
}
#include "nrpncases.h"
typedef void (* CaseFP)(int, float);

CaseFP CasesFP[] = {&case_0, &case_1, &case_2, &case_3, &case_4, &case_5, &case_6, &case_7, 0, 0, 0, &case_11, 0, &case_13, &case_14,  &case_15,&case_16, &case_17, &case_18};

void OnNrpn(int msb, int lsb, float val)
{
  if (val > 127)
    return;
  eeprom[msb * 128 + lsb] = val;
  //  Serial.println(val);
  if (CasesFP[msb])
    CasesFP[msb](lsb, val);


}


