void pad(float *array, int from, int to)
{
  float padval = array[from - 1];
  if (debug && 0)
  {
    Serial.print("padding ");
    Serial.print(from);
    Serial.print(" to " );
    Serial.print(to);
    Serial.print(" with " );
    Serial.print(padval);
  }
  for (int i = from; i < to; i++)
    array[i] = padval;
}
void OnSysEx(byte * array, unsigned size);
void OnSysExUSB(const uint8_t * array,  uint16_t size, bool complete)
{
  OnSysEx((byte *) array, size);
}
void OnSysEx(byte * array, unsigned size)
{
  AudioNoInterrupts();
  int s = 5;
  int t = array[4];
  int p = array[s];
  if ( t == 10 || t == 11 || t == 15 || t == 12)
    s = 7;
  if ( t == 13 || t == 14 || t == 16)
    s = 6;
  int o = array[s - 1];


  if (array[3] != size || debug)
  {
    Serial.print("cmd ");
    Serial.print(t);
    Serial.print(" ");
    Serial.print(p);
    Serial.print(" ");
    Serial.print(o);
    Serial.print(" ");
    Serial.print(array[3]);
    Serial.print(" ");
    Serial.println(size);
  }

  if (!alarm)
    alarm = array[3] != size;
  if (alarm)
    return;
  if (t == 1)
  {
    alarm = false;
    for (int pa = 0; pa < HarmInst.numharm; pa++)
      reset(0, -1, pa);
    mark = -1;
    endmark = -1;
    nh = p;
#if 0
    Serial.print(" nh ");
    Serial.print(nh);
    Serial.print(" mxh ");
    Serial.print(array[6]);
    Serial.print(" t ");
    Serial.print(array[7] * 4410.0 / array[5]);
    Serial.print(" ns ");
    Serial.println(array[5]);
    if (size > 9)
    {
      Serial.print(" click ");
      Serial.print(array[8]);
    }
    Serial.print(" ns ");
    Serial.println(array[5]);
#endif
    //   HarmInst.init(p,  array[6], array[5],   array[7] * 4410.0 / array[5]);

    HarmInst.init(p,  array[s], array[s + 1] );
    HarmInst.setnumharm(nh);
    HarmInst.setnumseg(array[s + 1]);
    for (int i = 0; i < nh; i++)
    {
      freqlist[i] = i + 1;
    }
    HarmInst.setVoice(0, 1,  freqlist, offlist, phaselist);
    if (size > 7)
      click = array[7];
    if (size > 8)
    {
         HarmInst.m_harm_fm->loopmark = array[8];
         HarmInst.m_harm_fm->loopend =array[9];
    }

  }
  else if (t == 2)
  {
    for (int pa = HarmInst.numharm; pa < p; pa++)
      reset(0, -1, pa);

    nh = p;
    HarmInst.setnumharm(nh);
    HarmInst.setnumseg(array[6]);
#if 0
    Serial.print(" nh ");
    Serial.print(nh);
    Serial.print(" ns ");
    Serial.println(array[6]);
#endif
  }
  else
  {
    int o = array[s - 1];
    if (debug)
    {
      Serial.print(" t ");
      Serial.print(t);
      Serial.print(" s ");
      Serial.print(s);
      Serial.print(" a[s]");
      Serial.print(array[s]);
      Serial.print(" a[s + 1]");
      Serial.print(array[s + 1]);
      Serial.print(" p ");
      Serial.print(p);
      Serial.print(" o ");
      Serial.print(o);
      Serial.println(" ");
    }
    unsigned i;
    for (i = s; i < size - 1 && t > 1; i++)
    {
      switch (t)
      {
        case 10:
          {
            float v1;
            float v2 = array[i] + float(array[i + 1]) / 100.0;
            v1 = v2 / 50.0 - 1;
            HarmInst.setlevels(p, (i - s) / 2 + o, v1);
            //           Serial.println(v1);
            if (debug)
            {
              Serial.print(i);
              Serial.print(" 10 ->");
              Serial.print((i - s) / 2 + o);
              Serial.print(" 10 ->");
              Serial.print(array[i]);
              Serial.print(" + ");
              Serial.print( array[i + 1]);
              Serial.print(" = ");
              Serial.print(v2);
              Serial.print(" -> ");
              Serial.print(v1);
              //             Serial.print("numseg =");
              //              Serial.print((i - s) / 2 + o);
              Serial.print(" => ");
              Serial.println( HarmInst.partials[p]->levels[ (i - s) / 2 + o]);
            }
            i++;
          }
          //          HarmInst.partials[p]->numseg = (i - s) / 2 + o+1;
          break;
        case 12:
          HarmInst.partials[p]->amps[i - s + o] = array[i] / 127.0;
          if (debug)
          {
            Serial.print("amp =");
            Serial.print(HarmInst.partials[p]->amps[i - s + o]);
            Serial.print("val =");
            Serial.println(array[i]);

          }
          break;
        case 16:
          HarmInst.setFreq((i - s) / 2 + p, array[i] + (float)array[i + 1] / 100.0);
          i++;
          break;
        case 13:
          HarmInst.setOffset(i - s + p, float(array[i]) / 10.0);
          break;
        case 14:
          HarmInst.setPhase(i - s + p, array[i]);
          break;
        case 15:
          HarmInst.partials[p]->times[i - s + o] = array[i] * 32.0;
          break;
      }
    }
    switch (t)
    {
      case 12:
        pad(HarmInst.partials[p]->amps, i - s, HarmInst.partials[p]->numseg);
        break;
      case 15:
        pad(HarmInst.partials[p]->times, i - s, HarmInst.partials[p]->numseg);
        break;
    }
    AudioInterrupts();

  }
}



