int mark = -1;
int endmark = -1;
int target = -1;
int sourcepart = -1;
extern int count;
int ci = 0;
float lf = 0;
int lastnote = 0;
float duration = 10;
int part = 0;
bool noff = false;
bool omni = false;
int segment = 0;
bool spread = false;
float bendFactor = 1;
int bendRange = 6;
extern HarmInstrument HarmInst;
extern bool debug;
byte notes[128];
int nh = 16;
#if 0
float levels[16][128];
float times[16][128];
#endif
float freqlist[16];
float offlist[16];
float phaselist[16];
#include "MIDINRPN.h"
#include "MIDISysex.h"
byte note = 0;
void dump()
{
  int   p = part;
  Serial.println(p);
  for (int t = 0; t < HarmInst.partials[part]->numseg; t++)
  {
    Serial.print(HarmInst.partials[p]->levels[t]);
    Serial.print(" ");
    Serial.print(HarmInst.partials[p]->slopes[t]);
    Serial.print(" ");
    Serial.print(HarmInst.partials[p]->af);
    Serial.print(" ");
     Serial.print(HarmInst.partials[p]->amps[t]);
    Serial.print(" ");
   Serial.print(HarmInst.partials[p]->times[t]*HarmInst.partials[p]->tf);
    Serial.println(" ");
  }
    HarmInst.m_harm_fm->envelope[part].debug=debug;
}
void modulate(int val)
{
  sine1.frequency(fmap(val, 0, 127, 0, 10));
  sine1.amplitude(1);

}
void OnNoteOn(byte channel, byte pnote, byte velocity)
{
  note = pnote;
  noff = false;
#if 0
  Serial.print(channel);
  Serial.print(" on ");
  Serial.print(note);
  Serial.print(" ");
  Serial.println(velocity);
#endif
  digitalWrite(ledPin, HIGH);
  count = 0;

  float fv = fmap(velocity, 0, 127, 0.2, 5.0);
  for (int i = 0; i < MP[ci]; i++)
  {
    if (busy[i] == -1)
    {
      instrument[i]->frequency(note_frequency[note]);
      instrument[i]->noteOn(lastnote, fv);
      dcs[i]->amplitude(fmap(velocity, 0, 127, 0, 1));
      notes[note] = i;
      busy[i] = 1;

    }
  }
  //  instrument[channel - 1]->processorUsageMaxReset();
  // AudioProcessorUsageMaxReset();

}

void OnNoteOff(byte channel, byte pnote, byte velocity)
{
#if 0
  Serial.print(channel);
  Serial.print(" off ");
  Serial.print(note);
  Serial.print(" ");
  Serial.println(velocity);
#endif
  noff = true;
  int n = notes[pnote];
  busy[n] = -1;
  if (!click)
    dcs[n]->amplitude(0, velocity);
  else
    dcs[n]->amplitude(0, 1);
  //  instrument[n]->noteOff(1, 0);
  notes[n] = -1;
}
void oscSet(float bendFactor)
{
  float bf = fmap(bendFactor, -8192, 8192, -1, 1);
  //  Serial.println(bf);
  dc2.amplitude(bf);
}
void OnPitchChange(byte channel, int bend)
{
#if 0
  Serial.print(channel);
  Serial.print(" ");
  Serial.println(bend);
#endif
  oscSet(bend);
}

void save(void)
{
  if (SD.exists("Harm.pre")) {
    // The SD library writes new data to the end of the
    // file, so to start a new recording, the old file
    // must be deleted before new data is written.
    SD.remove("Harm.pre");
  }
  File frec = SD.open("Harm.pre", FILE_WRITE);
  if (frec) {
    frec.write(eeprom, 16 * 1024);
    frec.write(&click, 1);
    frec.close();
    Serial.println("Preset saved");
  }
  if (SD.exists("Harm.ins")) {
    // The SD library writes new data to the end of the
    // file, so to start a new recording, the old file
    // must be deleted before new data is written.
    SD.remove("Harm.ins");
  }
  frec = SD.open("Harm.ins", FILE_WRITE);
  if (frec) {
    HarmInst.Save(frec);
    frec.close();
    Serial.println("Instr saved");
  }

}

void OnControlChange(byte channel, byte control, byte value)
{
  AudioNoInterrupts();
#if 0
  Serial.print("cc: ");
  Serial.print(control);
  Serial.print(" = ");
  Serial.println(value);
  Serial.print(" ");
#endif
  if (control == 1 )
    modulate(value);
  if (control == 50 && value == 127)
    save();
  if (control == 51 && value == 127)
    dump();
  AudioInterrupts();

}
