extern float fmap(float v, float im, float ia, float om, float ox);
union xi {
  int intval;
  float fval;
  byte bval[4];
} xs;
xi numh;
extern bool debug;
extern bool omni;
extern int part;

class Partial
{
  public:
    Partial(int pnumseg) {
      numseg = pnumseg;
      af = 1.0;
      tf = 1.0;
    };
    Partial(File frec) {
      Restore(frec);
    };
    void setUp(int segment)
    {
      float pl = levels[0];
      float m_time = times[0];
      float nl = 0;
      if (segment > 0)
      {
        pl = levels[segment - 1];
        m_time = times[segment - 1];
      }
      if (segment < numseg - 1)
        nl = levels[segment + 1];
      if (segment > 0)
        slopes[segment - 1] = (levels[segment] - pl) / m_time;
      slopes[segment] = (nl - levels[segment]) / m_time;
      if (debug && 0)
      {

        Serial.print(segment);
        Serial.print(" ");
        Serial.print(levels[segment]);
        Serial.print(" ");
        Serial.print(m_time);
        Serial.print(" ");
        Serial.print(slopes[segment]);
        Serial.print(" ");
        Serial.println(" ");
      }

    }

    void setUp()
    {
      for (int j = 0; j < numseg; j++)
      {
        float nl = 0;
        if (j < numseg - 1)
          nl = levels[j + 1];
        slopes[j] = (nl - levels[j]) / times[j];
#if 0
        Serial.print(j);
        Serial.print(" ");
        Serial.print(levels[j]);
        Serial.print(" ");
        Serial.print(times[j]);
        Serial.print(" ");
        Serial.print(slopes[j]);
        Serial.print(" ");
#endif
      }
      //     Serial.println(" ");

    }
    void setUp(float * plevels)
    {
      for (int j = 0; j < numseg; j++)
      {
        //      Serial.print(j);
        //      Serial.print(" ");
        //      Serial.print(m_time);
        //      Serial.println(" ");


        levels[j] = plevels[j];
        float nl = 0;
        if (j < numseg - 1)
          nl = plevels[j + 1];
        slopes[j] = (nl - levels[j]) / times[j];



        if (debug && 0)
        {
          Serial.print(j);
          Serial.print(" ");
          Serial.print(times[j]);
          Serial.print(" ");
          Serial.print(amps[j]);
          Serial.print(" ");
          Serial.print(levels[j]);
          Serial.print(" ");
          Serial.print(slopes[j]);
          Serial.print(" ");
        }
      }
      if (debug)      Serial.println(" ");


    }
    void Save(File frec)
    {

      numh.intval = numseg;
      frec.write((byte *)numh.bval, 4);
      frec.write((byte *)levels, numseg * 4);
      frec.write((byte *)slopes, numseg * 4);
      frec.write((byte *)amps, numseg * 4);
      frec.write((byte *)times, numseg * 4);
      numh.fval = af;
      frec.write((byte *)numh.bval,  4);
      numh.fval = tf;
      frec.write((byte *)numh.bval, 4);
      Serial.print("Saving part. ... numseg=");
      Serial.println(numseg);
      return;
    }

    void Restore(File frec)
    {
      Serial.print("Restoring part #seg= ");
      frec.read((byte *)numh.bval, 4);
      numseg = numh.intval;
      frec.read((byte *)levels, numseg * 4);
      frec.read((byte *)slopes, numseg * 4);
      frec.read((byte *)amps, numseg * 4);
      frec.read((byte *)times, numseg * 4);
      frec.read((byte *)numh.bval, 4);
      af = numh.fval;
      frec.read((byte *)numh.bval, 4);
      tf = numh.fval;
      Serial.println(numseg);
      return;
    }
    void setnumseg(int ns)
    {
      numseg = ns;
      if (debug)
      {
        Serial.print("numseg =");
        Serial.println(numseg);
      }
    }
    int numseg;
    float levels[128];
    float slopes[128];
    float amps[128];
    float times[128];
    float mfax;
    float tf;
    float af;
};

class HarmInstrument
{
  public:
    HarmInstrument(AudioSynthWaveformHarmModulated *harm_fm, File frec) {
      m_harm_fm = harm_fm;
      Restore(frec);
      setInstrument();
      m_harm_fm->partials(numharm);
    }
    HarmInstrument() {
    }
    HarmInstrument(File frec) {
      Serial.println("restoring...");
      Restore(frec);
      Serial.println("done restore");
    }
    HarmInstrument(int pnumharm, int pnumseg, float mfax) {
      init(pnumharm, pnumseg, mfax);
    }
    void init(int pnumharm, int pnumseg, float mf) {
      if (debug)
      {
        Serial.print("init ");
        Serial.println(pnumharm);
      }
      mfax = mf;
      numharm = pnumharm;
      for (int h = 0; h < numharm; h++)
      {
        if (partials[h] == 0)
          partials[h] = new Partial(pnumseg);
        if (m_harm_fm)
        {
          m_harm_fm->envelope[h].solo = false;
          m_harm_fm->envelope[h].mute = false;
          m_harm_fm->solos = 0;
        }
      }
      m_time = 32 * 127;
      if (debug)
      {
        Serial.print("init ");
        Serial.println(mfax);
      }

    }
    void adjust_slopes(int part, int fs, int ls, float duration, float amp)
    {
      for (int t = fs; t < ls; t++)
      {
        if (duration != -1)
          partials[part]->times[t] = duration;
        if (amp != -1)
          partials[part]->amps[t] = amp;
        float nl = 0;
        float af = partials[part]->amps[t] ;
        float tf = partials[part]->times[t] ;
        if (t < partials[part]->numseg - 1)
          nl = partials[part]->levels[t + 1];
        if (tf > 0)
          partials[part]->slopes[t] = 1 * (nl - partials[part]->levels[t]) / tf;
        m_harm_fm->envelope[part].amps[t] = partials[part]->amps[t];
      }
    }
    void attach(AudioSynthWaveformHarmModulated *harm_fm) {
      m_harm_fm = harm_fm;
      setInstrument();
      m_harm_fm->partials(numharm);
    }
    void Save(File frec)
    {
      numh.intval = numharm;
      frec.write((byte *)numh.bval, 4);
      numh.fval = mfax;
      frec.write((byte *)numh.bval, 4);
      numh.fval = m_time;
      frec.write((byte *)numh.bval, 4);
      Serial.print("Saving instr. ... mf=");
      Serial.print(mfax);
      Serial.print(" nh=");
      Serial.print(numharm);
      Serial.print(" m_time=");
      Serial.println(m_time);

      for (int h = 0; h < numharm; h++)
      {
        partials[h]->Save(frec);
      }
      frec.write((byte *)freqlist, numharm * 4);
      frec.write((byte *)offlist, numharm * 4);
      frec.write((byte *)phaselist, numharm * 4);
      numh.fval = 0;
      frec.write((byte *)numh.bval, 4);
      return;
    }

    void Restore(File frec)
    {
      frec.read((byte *)numh.bval, 4);
      numharm = numh.intval;
      frec.read((byte *)numh.bval, 4);
      mfax = numh.fval;
      frec.read((byte *)numh.bval, 4);
      m_time = numh.fval;
#if 1
      Serial.println(m_time);
      Serial.print("Restoring instr. ... mf=");
      Serial.print(mfax);
      Serial.print(" nh=");
      Serial.print(numharm);
      Serial.print(" m_time=");
      Serial.println(m_time);
#endif
      for (int h = 0; h < numharm; h++)
      {
        partials[h] = new Partial(frec);
      }
      frec.read((byte *)freqlist, numharm * 4);
      frec.read((byte *)offlist, numharm * 4);
      frec.read((byte *)phaselist, numharm * 4);
      frec.read((byte *)numh.bval, 4);
      return;
    }

    void setInstrument(AudioSynthWaveformHarmModulated *harm_fm, float *pfreqlist, float *pofflist, float *pphaselist)
    {
      for (int h = 0; h < numharm; h++)
      {
        freqlist[h] = pfreqlist[h];
        offlist[h] = pofflist[h];
        phaselist[h] = pphaselist[h];
      }
      m_harm_fm = harm_fm;
      m_harm_fm->partials(numharm);
      m_harm_fm->frequency(220.0);
      m_harm_fm->m_time = m_time;
      //      Serial.print("m_time ");
      //      Serial.println(m_time);
      setInstrument();

    }
    void setInstrument(void)
    {
      //      Serial.println(m_time);
      for (int h = 0; h < numharm; h++)
      {
        m_harm_fm->multiseg(partials[h]->levels, partials[h]->slopes, partials[h]->numseg, phaselist, h, partials[h]->times, partials[h]->amps);
        for (int i = 0; i < partials[h]->numseg; i++)
        {
          partials[h]->times[i] = m_time;
          //         partials[h]->amps[i] = 1.0;
        }
      }
      m_harm_fm->setFreq(freqlist, offlist, phaselist);
    }
    void setFreq(int h, float f)
    {

      freqlist[h] = f;
#if 0
      Serial.print(h);
      Serial.print(" = ");
      Serial.println(f);
#endif
    }
    void setOffset(int h, float f)
    {
      offlist[h] = f;
#if 0
      Serial.print(h);
      Serial.print(" off = ");
      Serial.println(f);
#endif
    }
    void setPhase(int h, float f)
    {
      phaselist[h] = f;
#if 0
      Serial.print(h);
      Serial.print(" = ");
      Serial.println(f);
#endif
    }
    void setAmplitude(int p, int seg, float val)
    {
      partials[p]->amps[seg] = val;
      //      m_harm_fm->multiseg(p, seg, val);

#if 1
      Serial.print(p);
      Serial.print(" = ");
      Serial.println(val);
#endif
    }
    void setDuration(int part, float val, int omni, int pmark, int pendmark)
    {
      float duration = fmap(val, 0, 127, 20, 2048);
      int rs = part, re = part + 1;
      int ss = pmark;
      int se = pendmark;
      if (omni)
      {
        if (debug)
        {
          Serial.print(omni);
          Serial.print(" Duration ");
          Serial.println(val / 64.0);
        }
        for (int h = 0; h < numharm; h++)
        {
          partials[h]->tf = val / 64.0;
          m_harm_fm->envelope[h].tf = val / 64.0;
          adjust_slopes(h, 0, partials[part]->numseg, -1, -1);
        }
      }
      else if (pmark < 0)
      {
        if (debug)
        {
          Serial.print(part);
          Serial.print(" Duration ");
          Serial.println(val / 64.0);
        }
        partials[part]->tf = val / 64.0;
        m_harm_fm->envelope[part].tf = val / 64.0;
        adjust_slopes(part, 0, partials[part]->numseg, -1, -1);
      }
      else if (pmark > -1)
      {
        adjust_slopes(part, ss, se, duration, -1);
        if (debug)
        {
          Serial.print("Set Duration in ");
          Serial.print(part);
          Serial.print(" from ");
          Serial.print(ss);
          Serial.print(" to ");
          Serial.print(se);
          Serial.print(" = ");
          Serial.println(duration);
        }
      }

    }
    void setlevels(int p, int seg, float val)
    {
      partials[p]->levels[seg] = val * mfax * 128;
#if 0
      Serial.print(mfax);
      Serial.print(", ");
      Serial.print(seg);
      Serial.print(", ");
      Serial.print(partials[p]->levels[seg]);
      Serial.print(", ");
      Serial.println(val);
#endif
    }
    void setup(int p)
    {
      partials[p]->setUp();
    }

    void setAmp(int part, float val, int omni, int pmark, int pendseg)
    {
      int hs = part;
      int he = part + 1;
      int ss = pmark;
      int se = pendseg;
      if (omni)
      {
        hs = 0;
        he = numharm;
      }
      if ( debug)
      {
        Serial.print("set amp hs:");
        Serial.print(hs);
        Serial.print(" mark: ");
        Serial.print(pmark);
        Serial.print(" omni: ");
        Serial.print(omni);
        Serial.print(" he: ");
        Serial.print(he);
        Serial.print(" ss: ");
        Serial.print(ss);
        Serial.print(" se:");
        Serial.print(se);
        Serial.print(" val: ");
        Serial.println(val);
      }
      if (omni)
      {
        for (int h = hs; h < he; h++)
        {
          m_harm_fm->envelope[h].af = val;
          partials[part]->af = val;
          //          adjust_slopes(h, 0, partials[part]->numseg, -1, -1);
        }
      }
      else if (pmark < 0)
      {
        m_harm_fm->envelope[part].af = val;
        partials[part]->af = val;
        //        adjust_slopes(part, 0, partials[part]->numseg, -1, -1);
      }
      else if (pmark > -1)
      {
        adjust_slopes(part, ss, se, -1, val);
      }
    }

    void setnumharm(int part)
    {
      m_harm_fm->partials(part);
      if (debug)
      {
        Serial.print("part ");
        Serial.println(part);
      }
      numharm = part;
    }
    void setnumseg(int ns)
    {
      setnumseg(ns, part);
    }
    void setnumseg(int ns, int p)
    {
      if (!omni)
        partials[p]->setnumseg(ns);
      for (int h = 0; h < numharm && omni; h++)
      {
        partials[h]->setnumseg(ns);
      }
      if (debug)
      {
        Serial.print("seg ");
        Serial.println(ns);
      }


      m_harm_fm->segments(ns);
    }

    void setVoice(int firstv, int lastv, float * pfreqlist, float * pofflist, float * pphaselist)
    {
      //      File frec = SD.open(filename, FILE_WRITE);
      AudioSynthWaveformHarmModulated *harm_fm = instrument[firstv];
      for (int i = 0; i < numharm; i++)
      {
        freqlist[i] = pfreqlist[i];
        offlist[i] = pofflist[i];
        phaselist[i] = pphaselist[i];
      }

      setInstrument(harm_fm, freqlist, offlist, phaselist);
      for (int voice = firstv + 1; voice < lastv; voice++)
      {
        AudioSynthWaveformHarmModulated *harm_fm = instrument[voice];
        setInstrument(harm_fm, freqlist, offlist, phaselist);
      }
    }
    void activate()
    {
      for (int p = 0; p < numharm; p++)
      {
        m_harm_fm->envelope[p].segments = partials[p]->numseg;
        adjust_slopes(p, 0, partials[p]->numseg, -1, -1);
      }
    }
  public:
    int numharm;
    float mfax;
    float m_time;
    AudioSynthWaveformHarmModulated *m_harm_fm = 0;
    Partial *partials[32] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    float freqlist[32];
    float offlist[32];
    float phaselist[32];
};
